apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ postgres_name }}
  namespace: {{ namespace }}
data:
{% if postgres_extensions | length > 0 %}
  load-extensions.sh: |
    #!/bin/sh
    if test "$DEBUG"; then
        set -x;
    fi;
    if test "$POSTGRES_APP_DB"; then
        psql -v ON_ERROR_STOP=1 --username "$POSTGRES_USER" --dbname "$POSTGRES_APP_DB" <<-EOSQL
{% for extension in postgres_extensions %}
    CREATE EXTENSION IF NOT EXISTS {{ extension }};
{% endfor %}
    EOSQL
    else
        psql -v ON_ERROR_STOP=1 --username "$POSTGRES_USER" --dbname "$POSTGRES_DB" <<-EOSQL
{% for extension in postgres_extensions %}
    CREATE EXTENSION IF NOT EXISTS {{ extension }};
{% endfor %}
    EOSQL
    fi
{% endif %}
  create-dbuser.sh: |
    #!/bin/sh
    if test "$DEBUG"; then
        set -x;
    fi;
    if test "$POSTGRES_APP_DB"; then
        if psql postgres -tAc "SELECT FROM pg_database WHERE datname = '$POSTGRES_APP_DB'" | grep -q $POSTGRES_APP_DB; then
            echo "NOTICE: database $POSTGRES_APP_DB already exists";
        else
            psql -v ON_ERROR_STOP=1 --username "$POSTGRES_USER" --dbname "$POSTGRES_DB" <<-EOSQL
    CREATE DATABASE $POSTGRES_APP_DB;
    EOSQL

            echo "NOTICE: created database $POSTGRES_APP_DB";
        fi;
    else
        POSTGRES_APP_DB=$POSTGRES_DB;
        echo "NOTICE: assuming POSTGRES_APP_DB=$POSTGRES_DB";
    fi;
    if test "$POSTGRES_APP_USER" -a "$POSTGRES_APP_PASSWORD"; then
        if psql postgres -tAc "SELECT 1 FROM pg_roles WHERE rolname='$POSTGRES_APP_USER'" | grep -q 1; then
            psql -v ON_ERROR_STOP=1 --username "$POSTGRES_USER" --dbname "$POSTGRES_DB" <<-EOSQL
    ALTER USER $POSTGRES_APP_USER WITH PASSWORD '$POSTGRES_APP_PASSWORD';
    GRANT ALL PRIVILEGES ON DATABASE $POSTGRES_APP_DB TO $POSTGRES_APP_USER;
    EOSQL

            echo "NOTICE: refreshed $POSTGRES_APP_USER password";
        else
            psql -v ON_ERROR_STOP=1 --username "$POSTGRES_USER" --dbname "$POSTGRES_DB" <<-EOSQL
    CREATE USER $POSTGRES_APP_USER;
    ALTER USER $POSTGRES_APP_USER WITH PASSWORD '$POSTGRES_APP_PASSWORD';
    GRANT ALL PRIVILEGES ON DATABASE $POSTGRES_APP_DB TO $POSTGRES_APP_USER;
    EOSQL

            echo "NOTICE: created user $POSTGRES_APP_USER, with privileges to $POSTGRES_APP_DB";
        fi;
    else
        echo "WARNING: missing POSTGRES_APP_USER and POSTGRES_APP_PASSWORD environment, sticking with admin credentials.";
    fi
